; Define your application name
!define APPNAME "AdiIRC"
!define APPNAMEANDVERSION "AdiIRC 1.8.10"
!include "UAC.nsh"

; Main Install settings
Name "${APPNAMEANDVERSION}"
InstallDir "$PROGRAMFILES\AdiIRC"
InstallDirRegKey HKLM "Software\${APPNAME}" ""
OutFile "setup.exe"

!include "DotNET.nsh"

!include "LogicLib.nsh"

!define DOTNET_VERSION "2"

; Modern interface settings
!include "MUI.nsh"

!define MUI_ABORTWARNING

;Installer icon
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\orange-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\orange-uninstall.ico"

;Installer header
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Header\orange.bmp"
!define MUI_HEADERIMAGE_UNBITMAP "${NSISDIR}\Contrib\Graphics\Header\orange-uninstall.bmp"
!define MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\orange.bmp"

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES

!define MUI_FINISHPAGE_RUN						""
!define MUI_FINISHPAGE_RUN_FUNCTION				"LaunchLink"
!define MUI_FINISHPAGE_SHOWREADME
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
!define MUI_FINISHPAGE_SHOWREADME_TEXT "Show release notes"
!define MUI_FINISHPAGE_SHOWREADME_FUNCTION ShowReleaseNotes

!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

; Set languages (first is default language)
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_RESERVEFILE_LANGDLL

RequestExecutionLevel user

Section "AdiIRC" Section1
	!insertmacro CheckDotNET "2"

	; Set Section properties
	SetOverwrite on

	; Set Section Files and Shortcuts
	SetOutPath "$INSTDIR\"
	File "AdiIRC.exe"
	File "CHANGED.txt"
	CreateShortCut "$DESKTOP\AdiIRC.lnk" "$INSTDIR\AdiIRC.exe"
	CreateDirectory "$SMPROGRAMS\AdiIRC"
	CreateShortCut "$SMPROGRAMS\AdiIRC\AdiIRC.lnk" "$INSTDIR\AdiIRC.exe"
	CreateShortCut "$QUICKLAUNCH\AdiIRC.lnk" "$INSTDIR\AdiIRC.exe"
	CreateShortCut "$SMPROGRAMS\AdiIRC\Uninstall.lnk" "$INSTDIR\uninstall.exe"

	SetOverwrite off
	File "config.ini"
	File "servers.ini"
	File "slaps.txt"

        CreateDirectory "$LOCALAPPDATA\AdiIRC"
	SetOutPath "$LOCALAPPDATA\AdiIRC"
	File "config.ini"
	File "servers.ini"
	File "slaps.txt"
SectionEnd

Section "Translations" Section2
    ; Set Section properties
	SetOverwrite on
	CreateDirectory "$INSTDIR\da-DK"
	SetOutPath "$INSTDIR\da-DK"
	File "Languages\da-DK\AdiIRC.resources.dll"
	
	CreateDirectory "$INSTDIR\es-ES"
	SetOutPath "$INSTDIR\es-ES"
	File "Languages\es-ES\AdiIRC.resources.dll"
	
	CreateDirectory "$INSTDIR\fr-FR"
	SetOutPath "$INSTDIR\fr-FR"
	File "Languages\fr-FR\AdiIRC.resources.dll"

	CreateDirectory "$INSTDIR\it-IT"
	SetOutPath "$INSTDIR\it-IT"
	File "Languages\it-IT\AdiIRC.resources.dll"

	CreateDirectory "$INSTDIR\pl-PL"
	SetOutPath "$INSTDIR\pl-PL"
	File "Languages\pl-PL\AdiIRC.resources.dll"

	CreateDirectory "$INSTDIR\zh-CN"
	SetOutPath "$INSTDIR\zh-CN"
	File "Languages\zh-CN\AdiIRC.resources.dll"
	SetOverwrite off
SectionEnd

Section -FinishSection

	WriteRegStr HKLM "Software\${APPNAME}" "" "$INSTDIR"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "DisplayName" "${APPNAME}"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "UninstallString" "$INSTDIR\uninstall.exe"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "DisplayIcon" "$INSTDIR\uninstall.exe,0"
	WriteUninstaller "$INSTDIR\uninstall.exe"

SectionEnd

; Modern install component descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT ${Section1} ""
!insertmacro MUI_FUNCTION_DESCRIPTION_END

;Uninstall section
Section Uninstall
	;Remove from registry...
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}"
	DeleteRegKey HKLM "SOFTWARE\${APPNAME}"

	; Delete self
	Delete "$INSTDIR\uninstall.exe"

	; Delete Shortcuts
	Delete "$DESKTOP\AdiIRC.lnk"
	Delete "$SMPROGRAMS\AdiIRC\AdiIRC.lnk"
	Delete "$SMPROGRAMS\AdiIRC\Uninstall.lnk"
	Delete "QUICKLAUNCH\AdiIRC.lnk"

	; Clean up AdiIRC
	Delete "$INSTDIR\AdiIRC.exe"
	Delete "$INSTDIR\upp.exe"
	Delete "$INSTDIR\CHANGED.txt"

	; Remove remaining directories
	RMDir "$SMPROGRAMS\AdiIRC"
	RMDir "$INSTDIR\"

	MessageBox MB_YESNO "Do you want to remove all settings and logs?" IDNO moveon
		RMDir /r "$INSTDIR\logs"
		RMDir /r "$INSTDIR\downloads"
		RMDir /r "$INSTDIR\themes"
		RMDir /r "$INSTDIR\plugins"
		RMDir /r "$INSTDIR\"

		RMDir /r "$LOCALAPPDATA\AdiIRC\logs"
		RMDir /r "$LOCALAPPDATA\AdiIRC\downloads"
		RMDir /r "$LOCALAPPDATA\AdiIRC\themes"
		RMDir /r "$LOCALAPPDATA\AdiIRC\plugins"
		RMDir /r "$LOCALAPPDATA\AdiIRC\"
	moveon:
SectionEnd

Function LaunchLink
         !insertmacro UAC_AsUser_ExecShell "open" "$INSTDIR\AdiIRC.exe" "" "" ""
FunctionEnd

Function ShowReleaseNotes
  ${If} ${FileExists} $WINDIR\notepad.exe
		Exec '$WINDIR\notepad.exe $INSTDIR\CHANGED.txt'
  ${EndIf}
FunctionEnd

Function un.onInit
	Call un.DoRightsElevation
FunctionEnd

Function .onInit
         Call DoRightsElevation
FunctionEnd

;====================================================================================
; UAC related functions
;====================================================================================

!macro RightsElevation un
    uac_tryagain:
    !insertmacro UAC_RunElevated
    #MessageBox mb_TopMost "0=$0 1=$1 2=$2 3=$3"
    ${Switch} $0
    ${Case} 0
        ${IfThen} $1 = 1 ${|} Quit ${|} ;we are the outer process, the inner process has done its work, we are done
        ${IfThen} $3 <> 0 ${|} ${Break} ${|} ;we are admin, let the show go on
        ${If} $1 = 3 ;RunAs completed successfully, but with a non-admin user
            MessageBox mb_IconExclamation|mb_TopMost|mb_SetForeground "This ${un}installer requires admin access, try again" /SD IDNO IDOK uac_tryagain IDNO 0
        ${EndIf}
        ;fall-through and die
    ${Case} 1223
        MessageBox mb_IconStop|mb_TopMost|mb_SetForeground "This ${un}installer requires admin privileges, aborting!"
        Quit
    ${Case} 1062
        MessageBox mb_IconStop|mb_TopMost|mb_SetForeground "Logon service not running, aborting!"
        Quit
    ${Default}
        MessageBox mb_IconStop|mb_TopMost|mb_SetForeground "Unable to elevate , error $0"
        Quit
    ${EndSwitch}
!macroend

Function DoRightsElevation
    !insertmacro RightsElevation ""
FunctionEnd

Function un.DoRightsElevation
    !insertmacro RightsElevation "un"
FunctionEnd
; eof